﻿/*
* Licensed to the Apache Software Foundation (ASF) under one
* or more contributor license agreements. See the NOTICE file
* distributed with this work for additional information
* regarding copyright ownership. The ASF licenses this file
* to you under the Apache License, Version 2.0 (the
* "License"); you may not use this file except in compliance
* with the License. You may obtain a copy of the License at
*
* http://www.apache.org/licenses/LICENSE-2.0
*
* Unless required by applicable law or agreed to in writing,
* software distributed under the License is distributed on an
* "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
* Kind, either express or implied. See the License for the
* specific language governing permissions and limitations
* under the License.
*/

namespace PortCMIS
{
    /// <summary>
    /// Binding type.
    /// </summary>
    public static class BindingType
    {
        /// <summary>Binding type AtomPub</summary>
        public const string AtomPub = "atompub";

        /// <summary>Binding type Web Services</summary>
        public const string WebServices = "webservices";

        /// <summary>Binding type Browser</summary>
        public const string Browser = "browser";

        /// <summary>Custom binding type</summary>
        public const string Custom = "custom";
    }
}
